# Android Vendor Test Suite (VTS)

VTS consists of a set of testing frameworks and test cases, designed to help
enhance the robustness, reliability, and compliance of:

  * the Android system (e.g., Core HALs and libraries) and
  * low-level system software (e.g., kernel, module, and firmware).

VTS has mainly two types of test suites:

  * automated (e.g., record-and-replay and fuzzing) and
  * structural (e.g., gTest and host-driven python) testing.

While the VTS framework and test cases are designed for userdebug or eng build
devices, some test cases can be run on user build devices using its app namely,
VTS Agent App.

__Table of Contents__

1. [VTS User Manual](doc/user_manual.md)
2. [Where to find VTS test cases](testcases/README.md)
3. [VTS Test Developer
   Manual (Codelab)](https://codelabs.developers.google.com/codelabs/android-vts)

